/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package enginerds.controller;

import java.awt.Color;
import java.awt.Font;
import java.awt.FontFormatException;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

/**
 *
 * @author CoderS_S
 */
public class Console extends JPanel {
    
    static final int TITLE_HEIGHT = 30;
    static final int BORDER = 4;
    static final Font MESSAGE_FONT = new Font("Courier New", Font.PLAIN, 20);
    static final Font TITLE_FONT = new Font("Calibri", Font.BOLD, 20);
    
    int w;
    int h;

    JLabel title;
    JScrollPane scroller;
    JTextArea messages;
    JButton buttonClear;
    
    public Console(int w, int h) {
        this(w, h, "Message Console");
    }
    
    public Console(int w, int h, String title) {
        this.w = w;
        this.h = h;
        
        this.setLayout(null);
        
        this.title = new JLabel(title);
        this.title.setBounds(BORDER, BORDER, w - (2 * BORDER), TITLE_HEIGHT - (2 * BORDER));
        this.title.setFont(TITLE_FONT);
        this.title.setHorizontalAlignment(JLabel.CENTER);
        this.title.setVerticalAlignment(JLabel.CENTER);
        this.add(this.title);
        
        messages = new JTextArea("Welcome to the Enginerds Controller!");
        messages.setBorder(BorderFactory.createLineBorder(Color.black));
        messages.setFont(MESSAGE_FONT);
        messages.setEditable(false);
        scroller = new JScrollPane(messages);
        scroller.setBounds(BORDER, TITLE_HEIGHT,
                w - (2 * BORDER), (h - (2 * TITLE_HEIGHT)));
        this.add(scroller);
        
        buttonClear = new JButton("Clear");
        buttonClear.setBounds(BORDER, (h - TITLE_HEIGHT) + BORDER,
                100 - (2 * BORDER), TITLE_HEIGHT - (2 * BORDER));
        buttonClear.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent ae) {
                messages.setText("Welcome to the Enginerds Controller!");
            }
        });
        this.add(buttonClear);
        
        this.setBorder(BorderFactory.createLineBorder(Controller.BORDER_COLOR, 2));
    }
    
    public void writeMessage(String line) {
        messages.setText(messages.getText() + "\n" + line);
        messages.setCaretPosition(messages.getDocument().getLength());
    }
    
}
