/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package enginerds.controller;

import java.awt.Color;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.io.File;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JTextPane;
import javax.swing.border.EmptyBorder;

/**
 *
 * @author CoderS_S
 */
public class ControlArea extends JPanel {
    
    static int PADDING = 10;
    static final int STATE_AUTO_TITRATING = 3;
    static final int STATE_MANUAL_TITRATING = 4;
    static final int STATE_RESULTS = 5;
    
    //Messages // also correspond to stages
    static String[] messages = {
        "Passive Mode",
        "Enter acid volume (mL)\nThen click ENTER",
        "Click ENTER to start titration\nEnter 1 for manual",
        "Auto titration in progress\nClick CLEAR to finish",
        "Manual titration in progress\n0-7 + CLEAR to control",
        "Titration ended!\nView results now :)"
    };
    
    //current message index
    int currentIndex;
    
    //third line of the screen
    String strEntered = "";
    
    JTextPane display = new JTextPane();
    NumberButton[] numButton = new NumberButton[10];
    JButton btnPoint = new JButton(".");
    
    JButton btnBack = new JButton("Backspace");
    JButton btnClear = new JButton("Clear");
    
    JButton btnEnter = new JButton("Enter");

    int displayHeight;
    int numButtonHeight;
    int numButtonWidth;
    
    public ControlArea(int w, int h) {
        displayHeight = h / 4;
        numButtonHeight = (h - displayHeight) / 4;
        numButtonWidth = (w / 5);
        
        setLayout(null);
        
        for (int i = 0; i < numButton.length; ++i) {
            numButton[i] = new NumberButton(i);
        }
        
        numButton[1].setBounds(
                0 * numButtonWidth + PADDING, 0 * numButtonHeight + displayHeight + PADDING,
                numButtonWidth - (2 * PADDING), numButtonHeight - (2 * PADDING));
        numButton[1].setMnemonic(KeyEvent.VK_1);
        numButton[2].setBounds(
                1 * numButtonWidth + PADDING, 0 * numButtonHeight + displayHeight + PADDING,
                numButtonWidth - (2 * PADDING), numButtonHeight - (2 * PADDING));
        numButton[2].setMnemonic(KeyEvent.VK_2);
        numButton[3].setBounds(
                2 * numButtonWidth + PADDING, 0 * numButtonHeight + displayHeight + PADDING,
                numButtonWidth - (2 * PADDING), numButtonHeight - (2 * PADDING));
        numButton[3].setMnemonic(KeyEvent.VK_3);
        numButton[4].setBounds(
                0 * numButtonWidth + PADDING, 1 * numButtonHeight + displayHeight + PADDING,
                numButtonWidth - (2 * PADDING), numButtonHeight - (2 * PADDING));
        numButton[4].setMnemonic(KeyEvent.VK_4);
        numButton[5].setBounds(
                1 * numButtonWidth + PADDING, 1 * numButtonHeight + displayHeight + PADDING,
                numButtonWidth - (2 * PADDING), numButtonHeight - (2 * PADDING));
        numButton[5].setMnemonic(KeyEvent.VK_5);
        numButton[6].setBounds(
                2 * numButtonWidth + PADDING, 1 * numButtonHeight + displayHeight + PADDING,
                numButtonWidth - (2 * PADDING), numButtonHeight - (2 * PADDING));
        numButton[6].setMnemonic(KeyEvent.VK_6);
        numButton[7].setBounds(
                0 * numButtonWidth + PADDING, 2 * numButtonHeight + displayHeight + PADDING,
                numButtonWidth - (2 * PADDING), numButtonHeight - (2 * PADDING));
        numButton[7].setMnemonic(KeyEvent.VK_7);
        numButton[8].setBounds(
                1 * numButtonWidth + PADDING, 2 * numButtonHeight + displayHeight + PADDING,
                numButtonWidth - (2 * PADDING), numButtonHeight - (2 * PADDING));
        numButton[8].setMnemonic(KeyEvent.VK_8);
        numButton[9].setBounds(
                2 * numButtonWidth + PADDING, 2 * numButtonHeight + displayHeight + PADDING,
                numButtonWidth - (2 * PADDING), numButtonHeight - (2 * PADDING));
        numButton[9].setMnemonic(KeyEvent.VK_9);
        numButton[0].setBounds(
                0 * numButtonWidth + PADDING, 3 * numButtonHeight + displayHeight + PADDING,
                (2 * numButtonWidth) - (2 * PADDING), numButtonHeight - (2 * PADDING));
        numButton[0].setMnemonic(KeyEvent.VK_0);
        btnPoint.setBounds(
                2 * numButtonWidth + PADDING, 3 * numButtonHeight + displayHeight + PADDING,
                numButtonWidth - (2 * PADDING), numButtonHeight - (2 * PADDING));

        btnBack.setBounds(
                3 * numButtonWidth + PADDING, 1 * numButtonHeight + displayHeight + PADDING,
                (2 * numButtonWidth) - (2 * PADDING), numButtonHeight - (2 * PADDING));
        btnClear.setBounds(
                3 * numButtonWidth + PADDING, 0 * numButtonHeight + displayHeight + PADDING,
                (2 * numButtonWidth) - (2 * PADDING), numButtonHeight - (2 * PADDING));
        
        btnEnter.setBounds(
                3 * numButtonWidth + PADDING, 3 * numButtonHeight + displayHeight + PADDING,
                (2 * numButtonWidth) - (2 * PADDING), numButtonHeight - (2 * PADDING));
        
        for (int i = 0; i < numButton.length; ++i) {
            numButton[i].setBackground(Color.lightGray);
            numButton[i].setFont(numButton[i].getFont().deriveFont(numButtonHeight * 0.5f));
            add(numButton[i]);
        }
        
        btnPoint.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent ae) {
                strEntered += ".";
                updateDisplay(">>> ");
                if (Controller.commandReader == null) {
                    Controller.console.writeMessage("Connect the board first!");
                } else {
                    Controller.commandReader.sendCommand(0);
                }
            }
        });
        btnBack.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent ae) {
                if (strEntered.length() > 0)
                    strEntered = strEntered.substring(0, strEntered.length() - 1);
                updateDisplay(">>> ");
            }
        });
        btnClear.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent ae) {
                if (currentIndex == STATE_AUTO_TITRATING ||
                    currentIndex == STATE_MANUAL_TITRATING) {//titrating
                    if (Controller.commandReader == null) {
                        Controller.console.writeMessage("Connect the board first!");
                    } else {
                        Controller.commandReader.sendCommand(SerialReader.COMMAND_MANUAL_STOP);
                        currentIndex = STATE_RESULTS;
                    }
                }
                if (strEntered.length() > 0)
                    strEntered = "";
                updateDisplay(">>> ");
            }
        });
        
        btnEnter.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent ae) {
                btnEnterPressed();
            }
        });

        btnPoint.setBackground(Color.lightGray);
        btnPoint.setFont(btnPoint.getFont().deriveFont(numButtonHeight * 0.5f));
        add(btnPoint);

        btnBack.setBackground(Color.gray.brighter());
        btnBack.setFont(btnBack.getFont().deriveFont(numButtonHeight * 0.3f));
        add(btnBack);

        btnClear.setBackground(new Color(255, 80, 80));
        btnClear.setFont(btnClear.getFont().deriveFont(numButtonHeight * 0.4f));
        add(btnClear);
        
        btnEnter.setBackground(new Color(120, 255, 85));
        btnEnter.setFont(btnEnter.getFont().deriveFont(numButtonHeight * 0.4f));
        add(btnEnter);
        
        Font displayFont = null;
        try {
            displayFont = Font.createFont(Font.TRUETYPE_FONT, new File("digital3.ttf"))
                    .deriveFont((float)((displayHeight - (2 * PADDING)) / 3f))
                    .deriveFont(Font.BOLD);
        } catch (Exception e) {
            e.printStackTrace();
            displayFont = new Font("Arial", Font.PLAIN, (int)((displayHeight - (2 * PADDING)) / 3.0));
        }

        
        currentIndex = 0;
        
        display.setBounds(PADDING, PADDING, w - (2 * PADDING), displayHeight - (2 * PADDING));
        display.setBackground(Color.black);
        display.setForeground(new Color(255, 50, 0));
        display.setEditable(false);
        display.setBorder(new EmptyBorder(PADDING, PADDING, PADDING, PADDING));
        display.setFont(displayFont);
        //display.setHorizontalAlignment(JLabel.LEFT);
        //display.setVerticalAlignment(JLabel.TOP);
        
        add(display);
        updateDisplay(">>> ");
    }
    
    public void updateDisplay(String prompt) {
        display.setText(messages[currentIndex] + "\n" + prompt + strEntered);
    }
    
    public void btnEnterPressed() {
        if (strEntered.equals("")) strEntered = "0";
        
        float value = 0.0f;
        try {
            value = Float.parseFloat(strEntered);
        } catch (Exception e) {
            e.printStackTrace();
            value = -1;
        }
        
        if (currentIndex == 0) {
            currentIndex++;
        } else if (currentIndex == 1 && value > 0) {//number values
            //value is the volume in milliliters
            if (Controller.commandReader == null) {
                Controller.console.writeMessage("Connect the board first!");
            } else {
                String floatRepresentation = Float.toString(value);
                Controller.commandReader.sendCommand(SerialReader.COMMAND_VOLUME_ML);
                for (int i = 0; i < floatRepresentation.length(); ++i) {
                    Controller.commandReader.sendCommand((int)floatRepresentation.charAt(i));
                }
                Controller.commandReader.sendCommand((int)('n'));
                currentIndex++;
            }
        } else if (currentIndex == 2) {
            //Time to start titration
            if (value == 1) {
                Controller.commandReader.sendCommand(SerialReader.COMMAND_START_MANUAL_TITRATING);
                currentIndex = STATE_MANUAL_TITRATING;
            } else {
                Controller.commandReader.sendCommand(SerialReader.COMMAND_START_AUTO_TITRATING);
                currentIndex = STATE_AUTO_TITRATING;
            }
        } else if (currentIndex == 3) {
            
        } else if (currentIndex == 4) {
            
        }
        
        if (value > 0) {
            String prompt = strEntered;
            strEntered = "";
            updateDisplay(prompt);
        } else {
            strEntered = "";
            updateDisplay("xxx ");
        }
    }
    
    public void beginControlling() {
        strEntered = "";
        currentIndex = 1;
        updateDisplay(">>> ");
    }
    
    class NumberButton extends JButton implements ActionListener {
        
        int n;
        
        public NumberButton(int n) {
            super(n + "");
            this.n = n;
            this.addActionListener(this);
        }

        @Override
        public void actionPerformed(ActionEvent ae) {
            if (currentIndex == STATE_MANUAL_TITRATING) {
                strEntered = n + "";
                updateDisplay("");
                Controller.commandReader.sendCommand('0' + n);
            } else {
                strEntered += n;
                updateDisplay(">>> ");
            }
        }
        
    }
    
}
