/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package enginerds.controller;

import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import javax.swing.JFrame;

/**
 *
 * @author CoderS_S
 */
public class Controller {
    
    static Color BORDER_COLOR = Color.lightGray;
    static String comPort = "COM12";
    static JFrame frame = new JFrame("Controller");

    static TitleArea title;
    
    static ControlArea controls;
    
    static GaugeArea gaugeLight;
    static GaugeArea gaugeVolume;
    static GaugeArea gaugePumpSpeed;
    
    static Digital digitalTemperature;
    static Digital digitalPH;

    static GraphArea graphArea;
    
    static Console console;
    
    static Reader commandReader;
    
    static Recorder commandRecorder = null;
    
    static Dumper dataDumper = null;
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        // TODO code application logic here
        MenuBar bar = new MenuBar();
        frame.setJMenuBar(bar);
        
        frame.setLayout(null);
        Container pane = frame.getContentPane();
        
        title = new TitleArea(1300, 100);
        title.setBounds(0, 0, 1300, 100);
        
        controls = new ControlArea(500, 400);
        controls.setBounds(400, 100, 500, 400);
        
        gaugeLight = new GaugeArea(400, 400, 1024.0, "Light", false, "");
        gaugeLight.setBounds(0, 100, 400, 400);
        gaugeVolume = new GaugeArea(200, 200, 300.0, "Volume", true, "mL");
        gaugeVolume.setBounds(900, 300, 200, 200);
        gaugePumpSpeed = new GaugeArea(200, 200, 100.0, "Pump Speed", true, "mL/min");
        gaugePumpSpeed.setBounds(1100, 300, 200, 200);

        String[] unitNames = {"C", "F"};
        String[] units = {"`", "`"};
        digitalTemperature = new Digital(200, 200, "Temperature", unitNames, units);
        digitalTemperature.setBounds(1100, 100, 200, 200);
        
        digitalPH = new Digital(200, 200, "pH", null, null);
        digitalPH.setBounds(900, 100, 200, 200);
        
        graphArea = new GraphArea(700, 450, 60000);
        graphArea.setBounds(0, 500, 700, 450);
        graphArea.addGraph("Light", 0, 1024.0);  //light
        graphArea.addGraph("Stir Speed", 0, 300.0);   //volume
        graphArea.addGraph("pH", -2.0, 16.0);  //pH
        graphArea.setUpBoundaries();

        console = new Console(600, 450);
        console.setBounds(700, 500, 600, 450);
        
        pane.add(title);
        
        pane.add(controls);
        
        pane.add(digitalTemperature);
        pane.add(digitalPH);
        
        pane.add(gaugeLight);
        pane.add(gaugeVolume);
        pane.add(gaugePumpSpeed);
        
        pane.add(graphArea);
        
        pane.add(console);
        
        pane.setPreferredSize(new Dimension(1300, 950));
        frame.pack();
        frame.setVisible(true);
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    }
    
    public static void setReader(Reader reader) {
        if (commandReader != null)
            commandReader.stop();
        commandReader = reader;
    }
     
}
