/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package enginerds.controller;

import java.awt.Color;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;

/**
 *
 * @author CoderS_S
 */
public class Digital extends JPanel {
    
    static int BORDER = 2;
    static int TITLE_HEIGHT = 40;
    
    int w;
    int h;
    
    double value;
    
    int currentUnitIndex;
    
    UnitButton[] buttonUnit;
    JLabel lblContent;
    
    String title;
    
    JLabel text;
    
    public Digital(int w, int h, String title, String[] unitNames, String[] unit) {
        this.w = w;
        this.h = h;
        
        this.title = title;
        
        value = 0;
        
        this.setLayout(null);

        Font myFont = null;
        try {
            myFont = Font.createFont(Font.TRUETYPE_FONT, new File("digital3.ttf"));
        } catch (Exception e) {
            e.printStackTrace();
        }
        
        if (unitNames == null) {
            currentUnitIndex = -1;
        } else {
            int buttonWidth = w / unitNames.length;
            buttonUnit = new UnitButton[unitNames.length];
            
            for (int i = 0; i < unitNames.length; ++i) {
                buttonUnit[i] = new UnitButton(unitNames[i], unit[i], i);

                buttonUnit[i].setBounds((i * buttonWidth) + BORDER, BORDER,
                        buttonWidth - (2 * BORDER), TITLE_HEIGHT - (2 * BORDER));
                buttonUnit[i].setFont(myFont.deriveFont(30f));
                this.add(buttonUnit[i]);
            }
        }
        
        lblContent = new JLabel("00");
        lblContent.setBounds(BORDER, BORDER,
                w - (2 * BORDER), h - (2 * BORDER));
        lblContent.setFont(myFont.deriveFont((float)(h - TITLE_HEIGHT) * 0.5f));
        lblContent.setForeground(Color.white);
        lblContent.setHorizontalAlignment(JLabel.CENTER);
        lblContent.setVerticalAlignment(JLabel.CENTER);
        this.add(lblContent);
        
        text = new JLabel(title);
        text.setBounds(BORDER, (h - TITLE_HEIGHT) + BORDER,
                w - (2 * BORDER), TITLE_HEIGHT - (2 * BORDER));
        text.setForeground(Color.white);
        text.setHorizontalAlignment(JLabel.CENTER);
        text.setFont(text.getFont().deriveFont(20f));
        this.add(text);
        
        this.setBackground(Color.black);
        this.setBorder(BorderFactory.createLineBorder(Controller.BORDER_COLOR, BORDER));
    }
    
    public void update() {
        update(value);
    }
    
    public void update(double value) {
        this.value = value;
        
        String unit;
        if (currentUnitIndex == -1) {
            text.setText(title);
            unit = "";
        } else {
            text.setText(title + " (" + buttonUnit[currentUnitIndex].getText() + ")");
            unit = buttonUnit[currentUnitIndex].unit;
        }
        
        //temperature specific
        if (currentUnitIndex == 0) {
        } else if (currentUnitIndex == 1) {
            value = ((9.0 / 5.0) * value) + 32.0;
        }
        
        lblContent.setText(String.format("%04.1f", (float)value) + unit);
    }
    
    class UnitButton extends JButton {
        
        int unitIndex;
        String unit;
        
        public UnitButton(String name, String unit, int unitIndex) {
            super(name);
            this.unitIndex = unitIndex;
            this.unit = unit;//a degree symbol/character(s) for example

            this.addActionListener(new ActionListener() {
                @Override
                public void actionPerformed(ActionEvent ae) {
                    currentUnitIndex = unitIndex;
                }
            });
        }
    }
    
}
