/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package enginerds.controller;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;

/**
 *
 * @author CoderS_S
 */
public class ReplayReader extends Reader {
    
    BufferedReader br;
    ActiveReader reader;
    boolean active;
    
    public ReplayReader(File file) {
        try {
            if (file == null)
                file = new File("output.txt");
            
            br = new BufferedReader(new FileReader(file));
        } catch (Exception e) {
            e.printStackTrace();
        }
        
        active = true;
        reader = new ActiveReader();
        reader.start();
    }
    
    public void receiveCommand(String prefix, String argString) {
        super.receiveCommand(prefix, argString);
    }
    
    public class ActiveReader extends Thread {
        public void run() {
            long startTime = System.currentTimeMillis();
            while (active) {
                try {
                    String prefix = br.readLine();
                    if (prefix == null) break;
                    String argString = br.readLine();
                    long time = Long.parseLong(br.readLine());
                    
                    long scheduledTime = time + startTime;
                    long currentTime = System.currentTimeMillis();
                    
                    if (scheduledTime < currentTime) {
                        //behind time
                        receiveCommand(prefix, argString);
                    } else {
                        Thread.sleep(scheduledTime - currentTime);
                        receiveCommand(prefix, argString);
                    }
                } catch (Exception e) {
                    e.printStackTrace();
                    break;
                }
            }
        }
    }
    
    public void stop() {
        active = false;
    }
    
}
